#if !defined(AFX_DESTINATIONDLG_H__A9FA038E_AA14_418B_8F03_96EFADE622F9__INCLUDED_)
#define AFX_DESTINATIONDLG_H__A9FA038E_AA14_418B_8F03_96EFADE622F9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DestinationDlg.h : header file
//

#include "Rom.h"

/////////////////////////////////////////////////////////////////////////////
// CDestinationDlg dialog

class CDestinationDlg : public CDialog
{
// Construction
public:

	void ChangeDestination(DestinationList *dest, int destination, int pointer, int x, int y, int eventFlag, bool checkFlag, int style);
	void RemoveDestination(DestinationList *dest, int destination, ObjectArea *areas);
	void AddDestination(DestinationList *dest, int type, int pointer, int x, int y, int direction, int eventFlag, bool checkFlag, int style);
	void ApplyChanges();
	void SelectDest(int destination);
	void InsertDestString(int i, int loc);
	void DisplayDestData();
	void RefreshListBox();

	CDestinationDlg(CWnd* pParent = NULL);						// standard constructor
	CDestinationDlg(CRom* rom, int dest, CWnd* pParent = NULL);	// Good constructor

	// this needs map tile data for nifty preview thingy
	CDC tempmap;
	CDC crosshair;
	//int *map_tiles[320][256];
	//int *gsets[80][32];
	//int *lsets[320][256];
	//int *gpals[80][32];

	CRom *ebRom;

	DestinationEntry dest;


	//int set_conv[32];
	//char *_tilesets[20][1024][32];
	//unsigned short *arranges[20][1024][16];

	//int mpal[32][8][6][16];


	// temporary copies of data for editing
	//DestinationList dest;
	//ObjectArea areas[1280];


	// states
	int sel_dest;	// selected destination in listbox

	bool request_seek;
	int seek_sel;
	int seek_x;
	int seek_y;


// Dialog Data
	//{{AFX_DATA(CDestinationDlg)
	enum { IDD = IDD_DESTINATIONDLG };
	CButton	m_Chk_Flag;
	CComboBox	m_Combo_Dir;
	CComboBox	m_Combo_Type;
	CListBox	m_ListBox;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDestinationDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDestinationDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnListBoxSelect();
	afx_msg void OnAdd();
	afx_msg void OnRemove();
	afx_msg void OnApply();
	afx_msg void OnPaint();
	afx_msg void OnSeek();
	virtual void OnOK();
	afx_msg int OnCharToItem(UINT nChar, CListBox* pListBox, UINT nIndex);
	afx_msg int OnVKeyToItem(UINT nKey, CListBox* pListBox, UINT nIndex);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DESTINATIONDLG_H__A9FA038E_AA14_418B_8F03_96EFADE622F9__INCLUDED_)
