#if !defined(AFX_EDITORENEMYGROUPDLG_H__1DFB7902_2918_4156_835F_E8CEF6A7EF26__INCLUDED_)
#define AFX_EDITORENEMYGROUPDLG_H__1DFB7902_2918_4156_835F_E8CEF6A7EF26__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// EditorEnemyGroupDlg.h : header file
//

#include "globals.h"
#include "rom.h"
#include "boxlist.h"
#include "listctrlex.h"

/////////////////////////////////////////////////////////////////////////////
// CEditorEnemyGroupDlg dialog

class CEditorEnemyGroupDlg : public CDialog
{
// Construction
public:
	void ApplyChanges();
	void BlendBGs(CDC* dc, int x, int y, int w, int h);
	void FillGroupList();
	void SelectGroup(int n);
	void ChangeBGPreview(int layer, int bg);
	void DisplayData(bool change_edit = TRUE, bool update_preview = TRUE);
	CEditorEnemyGroupDlg(CWnd* pParent = NULL);   // standard constructor
	CEditorEnemyGroupDlg(CRom* pRom, int nSel, CWnd* pParent = NULL);

	CRom *Rom;
	CEnemyBattleGroup group;
	int m_nSelGroup;

	CBoxList listbox;

	bool update_edit;

	HBITMAP m_hBG[2];	// Currently displayed bitmaps for bg preview
	int m_nBG[2];		// Numbers of bg thingies

	static CString* curpath;

// Dialog Data
	//{{AFX_DATA(CEditorEnemyGroupDlg)
	enum { IDD = IDD_ENEMYGROUPDLG };
	CSpinButtonCtrl	m_Spin2;
	CSpinButtonCtrl	m_Spin1;
	CComboBox	m_Combo_Group;
	CListCtrlEx	m_EnemyList;
	BOOL	m_bShowBlend;
	int		m_nLayerShown;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEditorEnemyGroupDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CEditorEnemyGroupDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg void OnGetdispinfoListEnemies(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnChangeEditBG1();
	afx_msg void OnChangeEditBG2();
	afx_msg void OnSelchangeComboGroup();
	afx_msg void OnCheckBlend();
	afx_msg void OnRadioBgl1();
	afx_msg void OnRadioBgl2();
	afx_msg void OnBtnApply();
	virtual void OnOK();
	afx_msg void OnDeltaposSpin1(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposSpin2(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBtnSave();
	afx_msg void OnBtnAdd();
	afx_msg void OnBtnRem();
	afx_msg void OnSelectLetterbox();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EDITORENEMYGROUPDLG_H__1DFB7902_2918_4156_835F_E8CEF6A7EF26__INCLUDED_)
