#if !defined(AFX_EDITORPALETTEDLG_H__5863D1FD_89F6_4D68_9725_A8CDA62B4E8C__INCLUDED_)
#define AFX_EDITORPALETTEDLG_H__5863D1FD_89F6_4D68_9725_A8CDA62B4E8C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// EditorPaletteDlg.h : header file
//

#include "rom.h"

/////////////////////////////////////////////////////////////////////////////
// CEditorPaletteDlg dialog

class CEditorPaletteDlg : public CDialog
{
// Construction
public:
	void ChangeColor(int r, int g, int b);
	void SetBarPos(int r, int g, int b);
	void DrawPalette(CDC* dc, int x, int y, int w, Palette pal);
	void ApplyChanges();
	void DisplayData();
	void SelectPalette(int,int);
	CEditorPaletteDlg(CWnd* pParent = NULL);   // standard constructor

	CRom *Rom;

	int tileset;
	int palette;

	int sel_pal;
	int sel_color;

	CRect palrect[6];
	CRect colorrect[16];

	bool slider_update;

// Dialog Data
	//{{AFX_DATA(CEditorPaletteDlg)
	enum { IDD = IDD_EDITOR_PALETTE };
	CSliderCtrl	m_Slider_R;
	CSliderCtrl	m_Slider_G;
	CSliderCtrl	m_Slider_B;
	CComboBox	m_Combo_Flash;
	CComboBox	m_Combo_Spritepal;
	CComboBox	m_Combo_Tileset;
	CComboBox	m_Combo_Pal;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEditorPaletteDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CEditorPaletteDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnEditchangeComboTileset();
	afx_msg void OnSelchangeComboTileset();
	afx_msg void OnEditchangeComboPal();
	afx_msg void OnSelchangeComboPal();
	afx_msg void OnPaint();
	afx_msg void OnBtnApply();
	afx_msg void OnCheckSpritepal();
	afx_msg void OnBtnSave();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EDITORPALETTEDLG_H__5863D1FD_89F6_4D68_9725_A8CDA62B4E8C__INCLUDED_)
