// MapMusicDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MapEdit.h"
#include "MapMusicDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


char* m_names[0xC0] = {
	"00 - None",
	"01 - Gas station",
	"02 - Naming screen",
	"03 - Setup screen",
	"04 - None",
	"05 - You win 1",
	"06 - Level up",
	"07 - You lose",
	"08 - Battle swirl 1",
	"09 - Battle swirl 2",
	"0A - What the heck? [Ness' house]",
	"0B - Fanfare [Battle swirl 3]",
	"0C - You win!",
	"0D - Teleport out",
	"0E - Teleport fail",
	"0F - Falling underground",
	"10 - Dr. Andonuts' lab",
	"11 - Monotoli building",
	"12 - Sloppy house",
	"13 - Neighbor's house",
	"14 - Arcade",
	"15 - Pokey's house",
	"16 - Hospital",
	"17 - Ness' house (Pollyanna)",
	"18 - Paula's theme",
	"19 - Chaos Theater",
	"1A - Hotel",
	"1B - Good morning",
	"1C - Department Store",
	"1D - Onett at night 1",
	"1E - Your Sanctuary 1",
	"1F - Your Sanctuary 2",
	"20 - Giant Step",
	"21 - Lilliput Steps",
	"22 - Milky Well",
	"23 - Rainy Circle",
	"24 - Magnet Hill",
	"25 - Pink Cloud",
	"26 - Lumine Hall",
	"27 - Fire Spring",
	"28 - near a boss",
	"29 - Alien Investigation",
	"2A - Fire Springs hall",
	"2B - Belch's Base",
	"2C - Zombie Threed",
	"2D - Spooky Cave",
	"2E - Onett",
	"2F - Fourside",
	"30 - Saturn Valley",
	"31 - Monkey Caves",
	"32 - Moonside",
	"33 - Dusty Dunes Desert",
	"34 - Peaceful Rest Valley",
	"35 - Zombie Threed",
	"36 - Winters",
	"37 - Cave near a boss",
	"38 - Summers",
	"39 - Jackie's Cafe",
	"3A - Sailing to Scaraba",
	"3B - Dalaam",
	"3C - Mu Training",
	"3D - Bazaar",
	"3E - Scaraba desert",
	"3F - Pyramid",
	"40 - Deep Darkness",
	"41 - Tenda Village",
	"42 - Welcome home",
	"43 - The Sea of Eden",
	"44 - Lost Underworld",
	"45 - First step back",
	"46 - Second step back",
	"47 - The Place",
	"48 - Giygas Awakens",
	"49 - Giygas phase 2",
	"4A - Giygas is weakened",
	"4B - Giygas death",
	"4C - Runaway 5 concert 1",
	"4D - Runaway 5 tour bus",
	"4E - Runaway 5 concert 2",
	"4F - Power",
	"50 - Venus' concert",
	"51 - Yellow submarine",
	"52 - Bicycle",
	"53 - Sky Runner",
	"54 - Sky Runner falling",
	"55 - Bulldozer",
	"56 - Tessie",
	"57 - City bus",
	"58 - Fuzzy Pickles",
	"59 - Delivery",
	"5A - Return to your body",
	"5B - Phase Distorter going back in time",
	"5C - Coffee break",
	"5D - Because I Love You",
	"5E - Good Friends, Bad Friends",
	"5F - Smiles and Tears",
	"60 - vs. Cranky Lady",
	"61 - vs. Spinning Robo",
	"62 - vs. S. Evil Mushroom",
	"63 - vs. Master Belch",
	"64 - vs. N. A. Retro Hippie",
	"65 - vs. Runaway Dog",
	"66 - vs. Cave Boy",
	"67 - vs. Your Sanctuary Boss",
	"68 - vs. Kraken",
	"69 - Giygas heavy metal",
	"6A - Inside the Dungeon",
	"6B - Megaton Walk",
	"6C - Sea of Eden",
	"6D - Explosion? [Stonehenge destructs]",
	"6E - Sky Runner crash",
	"6F - Magic Cake",
	"70 - Pokey's House (Buzz Buzz)",
	"71 - Buzz Buzz swatted",
	"72 - Onett at night (Buzz Buzz)",
	"73 - Phone call",
	"74 - Knock knock - right",
	"75 - Rabbit Cave",
	"76 - Onett at night 3",
	"77 - Apple of Enlightenment",
	"78 - Hotel of the Living Dead",
	"79 - Onett Intro",
	"7A - Sunrise, Onett",
	"7B - Someone joins",
	"7C - Enter Starman Jr.",
	"7D - Boarding school",
	"7E - Phase Distorter",
	"7F - Phase Distorter II",
	"80 - Boy Meets Girl (Twoson)",
	"81 - Happy Threed",
	"82 - Runaway 5 are freed",
	"83 - Flying Man",
	"84 - Onett at night 2",
	"85 - Hidden Song",
	"86 - Your Sanctuary boss",
	"87 - Teleport in",
	"88 - Saturn Valley cave",
	"89 - Elevator down",
	"8A - Elevator up",
	"8B - Elevator stopping",
	"8C - Topolla Theater",
	"8D - vs. Master Barf",
	"8E - going to Magicant",
	"8F - leaving Magicant",
	"90 - defeated the Kraken",
	"91 - stonehenge destructs",
	"92 - Tessie sighting",
	"93 - Meteor fall",
	"94 - vs. Starman Jr.",
	"95 - Runaway 5 help out",
	"96 - Knock knock - left",
	"97 - Onett after meteor 1",
	"98 - Onett after meteor 2",
	"99 - Pokey's theme",
	"9A - Onett at night 4 (Buzz Buzz)",
	"9B - Your Sanctuary boss",
	"9C - Meteor strike",
	"9D - Attract mode",
	"9E - Are you sure?  Yep",
	"9F - Peaceful Rest Valley 2",
	"A0 - rec. Giant Step",
	"A1 - rec. Lilliput Steps",
	"A2 - rec. Milky well",
	"A3 - rec. Rainy Circle",
	"A4 - rec. Magnet Hill",
	"A5 - rec. Pink Cloud",
	"A6 - rec. Lumine Hall",
	"A7 - rec. Fire Spring",
	"A8 - Sound Stone",
	"A9 - Eight Melodies",
	"AA - Dalaam Intro",
	"AB - Winters intro",
	"AC - Pokey escapes",
	"AD - Wake up - Moonside",
	"AE - Gas Station 2",
	"AF - Title screen",
	"B0 - Battle swirl (Normal)",
	"B1 - Pokey Intro",
	"B2 - Wake up - Scaraba",
	"B3 - Robotomy part 1",
	"B4 - Pokey escapes",
	"B5 - Return to your body",
	"B6 - Giygas static",
	"B7 - sudden victory",
	"B8 - You win vs. boss",
	"B9 - Giygas phase three",
	"BA - Giygas phase one",
	"BB - Give us strength",
	"BC - Good Morning",
	"BD - Sound Stone",
	"BE - Giygas death",
	"BF - Giygas weakened"
};
	
/////////////////////////////////////////////////////////////////////////////
// CMapMusicDlg dialog
	
	
CMapMusicDlg::CMapMusicDlg(CRom* pRom, int entry, CWnd* pParent /*=NULL*/)
	: CDialog(CMapMusicDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMapMusicDlg)
	//}}AFX_DATA_INIT

	cur_entry = entry;
	if(cur_entry > 163) cur_entry = 163;
	cur_event = 0;
	Rom = pRom;
}
	

void CMapMusicDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMapMusicDlg)
	DDX_Control(pDX, IDC_EDIT_FLAG, m_EditFlag);
	DDX_Control(pDX, IDC_LIST_EVENTS, m_ListBox);
	DDX_Control(pDX, IDC_SPIN_ENTRY, m_Spin);
	DDX_Control(pDX, IDC_COMBO_MUSIC, m_Combo_Music);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMapMusicDlg, CDialog)
	//{{AFX_MSG_MAP(CMapMusicDlg)
	ON_LBN_SELCHANGE(IDC_LIST_EVENTS, OnSelectEvent)
	ON_EN_CHANGE(IDC_EDIT_ENTRY, OnChangeEditEntry)
	ON_BN_CLICKED(IDC_APPLYCHANGES, OnApplyChanges)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_DELETE, OnDelete)
	ON_BN_CLICKED(IDC_BTN_SAVEROM, OnBtnSaverom)
	ON_CBN_SELCHANGE(IDC_COMBO_MUSIC, OnSelchangeComboMusic)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMapMusicDlg message handlers

BOOL CMapMusicDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	for(int i = 0; i < 164; i++)
		entries[i] = Rom->musictable[i];

	for(i = 0; i < 0xC0; i++)
		m_Combo_Music.InsertString(i, m_names[i]);
	
	// TODO: Add extra initialization here
	m_Spin.SetRange(0, 163);

	m_Spin.SetBuddy(GetDlgItem(IDC_EDIT_ENTRY));

	SetDlgItemInt(IDC_EDIT_ENTRY, cur_entry);

	//cur_entry = 0;
	cur_event = 0;

	//((CButton*)GetDlgItem(IDC_BTN_STOP))->SetIcon(LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_STOP)));
	//((CButton*)GetDlgItem(IDC_BTN_PLAY))->SetIcon(LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_PLAY)));

	toolbar.Create(WS_CHILD | CCS_NORESIZE | CCS_NODIVIDER | CCS_NOPARENTALIGN | TBSTYLE_FLAT, CRect(23, 162, 120, 190), this, 31338);

	toolbar.AddBitmap(1, IDB_MUSIC_STOP);
	toolbar.AddBitmap(1, IDB_MUSIC_PLAY);

	TBBUTTON btn;

	btn.idCommand = 0;
	btn.fsState = TBSTATE_ENABLED;
	btn.fsStyle = TBSTYLE_BUTTON;
	btn.iString = 0;

	btn.iBitmap = 0;
	btn.idCommand = 1024;
	toolbar.AddButtons(1, &btn);

	btn.iBitmap = 1;
	btn.idCommand = 1025;
	toolbar.AddButtons(1, &btn);


	toolbar.ShowWindow(SW_NORMAL);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


BOOL CMapMusicDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	int id = LOWORD(wParam);

	switch(id)
	{
	case 1025:
		Rom->PlayMusic(m_Combo_Music.GetCurSel());
		break;
	case 1024:
		Rom->StopMusic();
		break;
	}
	return CDialog::OnCommand(wParam, lParam);
}


void CMapMusicDlg::DisplayEntryData(int entry, int event)
{
	SetDlgItemText(IDC_EDIT_FLAG, FormatSNESAdr(entries[entry].events[event].flag));

	m_Combo_Music.SetCurSel(entries[entry].events[event].music);


	if(entries[cur_entry].events[cur_event].flag == 0)
	{
		m_EditFlag.EnableWindow(FALSE);
	}
	else
	{
		m_EditFlag.EnableWindow();
	}
}

void CMapMusicDlg::SelectEntry(int entry)
{
	cur_entry = entry;
	cur_event = 0;

	DisplayListBox(entry);
	DisplayEntryData(entry, 0);
}

void CMapMusicDlg::DisplayListBox(int entry)
{
	m_ListBox.ResetContent();

	for(int i = 0; i < entries[entry].num_events; i++)
	{
		CString s;
		if(entries[entry].events[i].flag != 0)
			s.Format("%s\t%s", FormatSNESAdr(entries[entry].events[i].flag), m_names[entries[entry].events[i].music]);
		else
			s.Format("Default\t%s", m_names[entries[entry].events[i].music]);

		m_ListBox.InsertString(-1, s);
	}
	m_ListBox.SetCurSel(cur_event);
}

void CMapMusicDlg::OnSelectEvent() 
{
	// TODO: Add your control notification handler code here
	cur_event = m_ListBox.GetCurSel();
	DisplayEntryData(cur_entry, cur_event);
}

void CMapMusicDlg::OnChangeEditEntry() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	int entry = GetDlgItemInt(IDC_EDIT_ENTRY);

	if(entry < 164)
	{
		SelectEntry(entry);
	}
}


void CMapMusicDlg::ApplyChanges()
{
	CString s;
	GetDlgItemText(IDC_EDIT_FLAG, s);

	int flag = DeformatSNESAdr(s);

	if(flag == 0 && entries[cur_entry].events[cur_event].flag != 0)
	{
		AfxMessageBox("Error: only default music can have null flag value");
		return;
	}

	int music = m_Combo_Music.GetCurSel();

	entries[cur_entry].events[cur_event].flag = flag;
	entries[cur_entry].events[cur_event].music = music;

	DisplayListBox(cur_entry);
}

void CMapMusicDlg::OnApplyChanges() 
{
	// TODO: Add your control notification handler code here
	ApplyChanges();
}

void CMapMusicDlg::OnAdd() 
{
	// TODO: Add your control notification handler code here
	int n_events = entries[cur_entry].num_events;

	entries[cur_entry].events[n_events] = entries[cur_entry].events[n_events-1];

	entries[cur_entry].events[n_events-1].flag = 1;
	entries[cur_entry].events[n_events-1].music = 0;

	entries[cur_entry].num_events++;

	cur_event = n_events-1;

	DisplayListBox(cur_entry);
	DisplayEntryData(cur_entry, cur_event);
}

void CMapMusicDlg::OnDelete() 
{
	if(entries[cur_entry].events[cur_event].flag == 0)
	{
		AfxMessageBox("Error: cannot delete default entry");
		return;
	}

	for(int i = cur_event; i < entries[cur_entry].num_events-1; i++)
		entries[cur_entry].events[i] = entries[cur_entry].events[i+1];;
	entries[cur_entry].num_events--;

	if(cur_event >= entries[cur_entry].num_events)
		cur_event = entries[cur_entry].num_events-1;

	DisplayListBox(cur_entry);
	DisplayEntryData(cur_entry, cur_event);
}


void CMapMusicDlg::OnOK() 
{
	// TODO: Add extra validation here
	for(int i = 0; i < 164; i++)
	{
		Rom->musictable[i] = entries[i];
	}

	CDialog::OnOK();
}

void CMapMusicDlg::OnBtnSaverom() 
{
	for(int i = 0; i < 164; i++)
	{
		Rom->musictable[i] = entries[i];
	}
	Rom->Save();
}

void CMapMusicDlg::OnSelchangeComboMusic() 
{
	if(Rom->music_playing != -1)
		Rom->PlayMusic(m_Combo_Music.GetCurSel());
}


