#if !defined(AFX_SPRITEDLG_H__EF5DD8BC_765F_49A1_B02A_CF2520901597__INCLUDED_)
#define AFX_SPRITEDLG_H__EF5DD8BC_765F_49A1_B02A_CF2520901597__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SpriteDlg.h : header file
//
#include "classes.h"
#include "rom.h"

/////////////////////////////////////////////////////////////////////////////
// CSpriteDlg dialog

class CSpriteDlg : public CDialog
{
// Construction
public:
	void ApplyChanges();
	void ApplyTPTChanges();
	void DisplaySpriteData();
	CSpriteDlg(CWnd* pParent = NULL);   // standard constructor
	CSpriteDlg(int, int, CWnd* pParent = NULL);

	CRom* Rom;

	int n_area;
	int n_sprite;

	SpriteEntry sprite;	// Sprite being edited

	TPTEntry tpt[1583];	// Copy of TPT



	// graphics (Soon to be obsolete-ified)
	//SpriteGfx sprite_gfx[1144];
	//Palette pal[8];

	// misc
	BOOL user_edited;

// Dialog Data
	//{{AFX_DATA(CSpriteDlg)
	enum { IDD = IDD_SPRITEDLG };
	CComboBox	m_Combo_Usage;
	CComboBox	m_ItemList;
	CSpinButtonCtrl	m_Spin;
	CComboBox	m_Combo_Type;
	CComboBox	m_Combo_Dir;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSpriteDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CSpriteDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg void OnChangeEditSprite();
	afx_msg void OnChangeEditTptNum();
	afx_msg void OnApplyTPT();
	virtual void OnOK();
	afx_msg void OnSelectType();
	afx_msg void OnSelectDir();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SPRITEDLG_H__EF5DD8BC_765F_49A1_B02A_CF2520901597__INCLUDED_)
