#if !defined(AFX_DOORDLG_H__30BE936E_E3E8_44FF_9B55_87222BE09187__INCLUDED_)
#define AFX_DOORDLG_H__30BE936E_E3E8_44FF_9B55_87222BE09187__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DoorDlg.h : header file
//
#include "classes.h"
#include "Rom.h"

#include "DoorRopeDlg.h"
#include "DoorEscDlg.h"
#include "DoorStairDlg.h"

/////////////////////////////////////////////////////////////////////////////
// CDoorDlg dialog

class CDoorDlg : public CDialog
{
// Construction
public:
	void RefreshListBox();
	void ApplyChanges();
	void DisplayDoorData();
	CDoorDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CDoorDlg)
	enum { IDD = IDD_DOORDLG };
	CSpinButtonCtrl	m_DestSpin;
	CComboBox	m_Combo_Type;
	CListBox	m_ListBox;
	//}}AFX_DATA

	//DestinationList dest;

	// pointer to ROM object
	CRom *ebRom;

	// temporary door entry
	DoorEntry door;

	int n_area;
	int n_door;

	//CDC *tilesets;
	CBitmap m_bmpCrosshair;

	//CDC tbuf;
	//CDC buf,buf2;
	//CDC tempmap;
	//CDC crosshair;

	//int *map_tiles[320][256];
	//int *gsets[80][32];
	//int *lsets[320][256];
	//int *gpals[80][32];


	//int set_conv[32];
	//char *_tilesets[20][1024][32];
	//unsigned short *arranges[20][1024][16];

	//int mpal[32][8][6][16];


	CDoorRopeDlg ropewin;
	CDoorEscDlg escwin;
	CDoorStairDlg stairwin;


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDoorDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnOK();
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDoorDlg)
	afx_msg void OnSelectType();
	afx_msg void OnBtnEditDest();
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg void OnEditDest();
	afx_msg void OnSelectDest();
	virtual void OnCancel();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DOORDLG_H__30BE936E_E3E8_44FF_9B55_87222BE09187__INCLUDED_)
