// DoorEscDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MapEdit.h"
#include "DoorEscDlg.h"
#include "DoorDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDoorEscDlg dialog


CDoorEscDlg::CDoorEscDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDoorEscDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDoorEscDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDoorEscDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDoorEscDlg)
	DDX_Control(pDX, IDC_CHECK_END, m_Chk_End);
	DDX_Control(pDX, IDC_SEL_DIR_UR, m_Sel_UR);
	DDX_Control(pDX, IDC_SEL_DIR_UL, m_Sel_UL);
	DDX_Control(pDX, IDC_SEL_DIR_DR, m_Sel_DR);
	DDX_Control(pDX, IDC_SEL_DIR_DL, m_Sel_DL);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDoorEscDlg, CDialog)
	//{{AFX_MSG_MAP(CDoorEscDlg)
	ON_BN_CLICKED(IDC_CHECK_END, OnCheckEnd)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDoorEscDlg message handlers

BOOL CDoorEscDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_Sel_UL.SetIcon((HICON)LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_DIR_UL), IMAGE_ICON, 0, 0, 0));
	m_Sel_UR.SetIcon((HICON)LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_DIR_UR), IMAGE_ICON, 0, 0, 0));
	m_Sel_DL.SetIcon((HICON)LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_DIR_DL), IMAGE_ICON, 0, 0, 0));
	m_Sel_DR.SetIcon((HICON)LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_DIR_DR), IMAGE_ICON, 0, 0, 0));

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDoorEscDlg::OnCheckEnd() 
{
	// TODO: Add your control notification handler code here
	((CDoorDlg*)GetParent())->ApplyChanges();
}
