#if !defined(AFX_LISTCTRLEX_H__FC697DE3_9836_401C_8091_59D1D93883DC__INCLUDED_)
#define AFX_LISTCTRLEX_H__FC697DE3_9836_401C_8091_59D1D93883DC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ListCtrlEx.h : header file
//

#define LVX_LBUTTONDOWN	0x30
#define LVX_RBUTTONDOWN	0x31
#define LVX_SELCHANGE	0x32

/////////////////////////////////////////////////////////////////////////////
// CListCtrlEx window

class CListCtrlEx : public CListCtrl
{
// Construction
public:
	CListCtrlEx();

// Attributes
public:
	COLORREF m_clrItemColor;
	COLORREF m_clrItemShadow;

	int m_nOldSel;

// Operations
public:
	void SetItemColors(int rgbColor, int rgbShadow);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CListCtrlEx)
	//}}AFX_VIRTUAL

// Implementation
public:
	void CheckSelection();
	void DrawBoxes(int nBox, int x, int y, CDC *dc);
	void DrawBox(CRect rect, CDC *dc);
	void UpdateSubItems();
	virtual ~CListCtrlEx();

	// Generated message map functions
protected:

	//{{AFX_MSG(CListCtrlEx)
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDblClk(UINT nFlags, CPoint point);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LISTCTRLEX_H__FC697DE3_9836_401C_8091_59D1D93883DC__INCLUDED_)
