#if !defined(AFX_MAPMUSICDLG_H__4D13EA69_F819_438F_B10F_33424E2CAADE__INCLUDED_)
#define AFX_MAPMUSICDLG_H__4D13EA69_F819_438F_B10F_33424E2CAADE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MapMusicDlg.h : header file
//

#include "classes.h"
#include "Rom.h"

/////////////////////////////////////////////////////////////////////////////
// CMapMusicDlg dialog

class CMapMusicDlg : public CDialog
{
// Construction
public:
	void ApplyChanges();
	void DisplayListBox(int entry);
	void SelectEntry(int entry);
	void DisplayEntryData(int entry, int event);
	CMapMusicDlg(CRom* pRom, int entry, CWnd* pParent = NULL);   // standard constructor

	CRom* Rom;

	MapMusicEntry entries[164];

	CToolBarCtrl toolbar;

	int cur_entry;
	int cur_event;

// Dialog Data
	//{{AFX_DATA(CMapMusicDlg)
	enum { IDD = IDD_MAPMUSICDLG };
	CEdit	m_EditFlag;
	CListBox	m_ListBox;
	CSpinButtonCtrl	m_Spin;
	CComboBox	m_Combo_Music;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMapMusicDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CMapMusicDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelectEvent();
	afx_msg void OnChangeEditEntry();
	afx_msg void OnApplyChanges();
	afx_msg void OnAdd();
	afx_msg void OnDelete();
	virtual void OnOK();
	afx_msg void OnBtnSaverom();
	afx_msg void OnSelchangeComboMusic();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAPMUSICDLG_H__4D13EA69_F819_438F_B10F_33424E2CAADE__INCLUDED_)
