#if !defined(AFX_SECTORPROPWND_H__BD578C7B_4C43_4952_BEEC_DD3817971475__INCLUDED_)
#define AFX_SECTORPROPWND_H__BD578C7B_4C43_4952_BEEC_DD3817971475__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SectorPropWnd.h : header file
//
#include "Rom.h"

#define SP_CHANGE WM_USER+0x50

/////////////////////////////////////////////////////////////////////////////
// CSectorPropWnd dialog

class CSectorPropWnd : public CDialog
{
// Construction
public:
	void Enable(bool bEnable);
	void InitItemBox(CRom *pRom);
	void DisplayData();
	unsigned short GetSectorFlags();
	void SetSectorFlags(unsigned short sFlags);
	CSectorPropWnd(CWnd* pParent = NULL);   // standard constructor

	unsigned short m_sFlags;

	CFont font;

// Dialog Data
	//{{AFX_DATA(CSectorPropWnd)
	enum { IDD = IDR_TOOL_SECTORPROP };
	CComboBox	m_Combo_Map;
	CComboBox	m_Combo_Special;
	CComboBox	m_Combo_Item;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSectorPropWnd)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CSectorPropWnd)
	afx_msg void OnCheckTeleport();
	afx_msg void OnSelchangeItem();
	afx_msg void OnSelchangeSpecial();
	afx_msg void OnSelchangeTownmap();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SECTORPROPWND_H__BD578C7B_4C43_4952_BEEC_DD3817971475__INCLUDED_)
